/*   *_> CNLLSTSPLF SRCFILE(@2/@1) SRCMBR(@3)                              */
/*   *_> DLTMOD MODULE(@5/@4)                                               */
/*   *_> CRTCLMOD MODULE(@5/@4) SRCFILE(@2/@1) SRCMBR(@3) +                 */
/*   *_>   DBGVIEW(@9) OPTIMIZE(@8)                                         */
/*   *----------------------------------------------------------------      */
/*   * Module.: XV0006_M01                  Project:                        */
/*   * Author : A. Campin                   Date Written: 05/07/2004        */
/*   * Purpose: CPP for INDENT.                                             */
/*   *---------------------------------------------------------------       */
/*   * Called by: CPP for INDENT.                                           */
/*   *---------------------------------------------------------------       */
/*   * Revision history:                                                    */
/*   *  Proj#  Pgmr          Date    Description of change.                 */
/*   *                                                                      */
/*   * End Revision history:                                                */
/*   *---------------------------------------------------------------       */
             PGM        PARM(&SRCFILLIB &SRCMBR &OUTPUT1 &LEVELSTOI +
                          &FROMRCD &TORCD &SPECS &PRTCMT)

             DCL        VAR(&SRCFILLIB) TYPE(*CHAR) LEN(20) /* +
                          Qualified Source File Name */
             DCL        VAR(&SRCMBR) TYPE(*CHAR) LEN(10) /* Source +
                          Member Name. */
             DCL        VAR(&OUTPUT1) TYPE(*CHAR) LEN(1) /* Display +
                          (*) or Print (P) */
             DCL        VAR(&LEVELSTOI) TYPE(*DEC) LEN(1 0) /* +
                          Levels to Ident. */
             DCL        VAR(&FROMRCD) TYPE(*DEC) LEN(6 2) /* From +
                          Record Number. */
             DCL        VAR(&TORCD) TYPE(*DEC) LEN(6 2) /* To Record +
                          Number. */
             DCL        VAR(&SPECS) TYPE(*CHAR) LEN(11) /* List of +
                          Specs types to include. */
             DCL        VAR(&PrtCmt) TYPE(*CHAR) LEN(1) /* Print +
                          comments Yes or No. */
             DCL        VAR(&OUTQ) TYPE(*CHAR) LEN(10)

             DCL        VAR(&SRCFILE) TYPE(*CHAR) LEN(10)
             DCL        VAR(&LIBRARY) TYPE(*CHAR) LEN(10)
             DCL        VAR(&SRCTYPE) TYPE(*CHAR) LEN(10)
             DCL        VAR(&RETURNCODE) TYPE(*CHAR) LEN(1)
             DCL        VAR(&MSGID) TYPE(*CHAR) LEN(7)
             DCL        VAR(&MSGDTA) TYPE(*CHAR) LEN(100)
             DCL        VAR(&MSGF) TYPE(*CHAR) LEN(10)
             DCL        VAR(&MSGFLIB) TYPE(*CHAR) LEN(10)

/* Unmonitored messages goto error */

             MONMSG     MSGID(CPF0000) EXEC(GOTO CMDLBL(ERROR))

/* Split the command fields into program fields                               */

             CHGVAR     VAR(&SRCFILE) VALUE(%SUBSTRING(&SRCFILLIB 1 +
                          10))
             CHGVAR     VAR(&LIBRARY) VALUE(%SUBSTRING(&SRCFILLIB 11 +
                          10))

/* Validate that source file exists and that we have authority +
   to read */

             CHKOBJ     OBJ(&LIBRARY/&SRCFILE) OBJTYPE(*FILE) +
                          AUT(*READ)

/* Validate that member exists within source file                             */

             CHKOBJ     OBJ(&LIBRARY/&SRCFILE) OBJTYPE(*FILE) +
                          MBR(&SRCMBR)

/* Validate that member is correct type.                                      */

             RTVMBRD    FILE(&LIBRARY/&SRCFILE) MBR(&SRCMBR) +
                          SRCTYPE(&SRCTYPE)

             IF         COND((&SRCTYPE *EQ 'RPG') *OR (&SRCTYPE *EQ +
                          'RPGLE') *OR (&SRCTYPE *EQ 'RPT') *OR +
                          (&SRCTYPE *EQ 'SQLRPG') *OR (&SRCTYPE *EQ +
                          'SQLRPGLE')) THEN(GOTO CMDLBL(TYPE_VALID))

               SNDPGMMSG  MSGID(UXV0007) MSGF(*LIBL/XVMSGF) +
                            MSGDTA(&SRCFILE *CAT &LIBRARY *CAT +
                            &SRCMBR *CAT &SRCTYPE) MSGTYPE(*ESCAPE)
TYPE_VALID:

/* Allocate the source member */

             ALCOBJ     OBJ((&LIBRARY/&SRCFILE *FILE *SHRUPD +
                          &SRCMBR)) WAIT(0)

             RTVJOBA    OUTQ(&OUTQ)

/* If printing the listing */

               IF         COND(&OUTPUT1 *EQ 'P') THEN(OVRPRTF +
                            FILE(XV0006_P01) OUTQ(&OUTQ) HOLD(*NO) +
                            USRDTA('Indent') SPLFNAME(&SRCMBR) +
                            OVRSCOPE(*CALLLVL))
               ELSE       CMD(OVRPRTF FILE(XV0006_P01) SPOOL(*YES) +
                            HOLD(*YES) OVRSCOPE(*CALLLVL))

/* call the proper print program.                                             */

             IF         COND((&SRCTYPE *EQ 'RPG') *OR (&SRCTYPE *EQ +
                          'SQLRPG') *OR (&SRCTYPE *EQ 'RPT')) THEN(DO)

/* Override to the proper file, lib, mbr. */

               OVRDBF     FILE(QRPGSRC) TOFILE(&LIBRARY/&SRCFILE) +
                            MBR(&SRCMBR) WAITFILE(1) LVLCHK(*NO) +
                            SECURE(*YES) OVRSCOPE(*CALLLVL)

               CALLPRC    PRC('PrintRPGIII') PARM(&SRCFILE &LIBRARY +
                            &SRCMBR &LEVELSTOI &FROMRCD &TORCD &SPECS +
                            &PRTCMT)
             ENDDO
             ELSE       CMD(DO)

               OVRDBF     FILE(QRPGLESRC) TOFILE(&LIBRARY/&SRCFILE) +
                            MBR(&SRCMBR) WAITFILE(1) LVLCHK(*NO) +
                            SECURE(*YES) OVRSCOPE(*CALLLVL)
               CALLPRC    PRC('PrintRPGIV') PARM(&SRCFILE &LIBRARY +
                            &SRCMBR &LEVELSTOI &FROMRCD &TORCD &SPECS +
                            &PRTCMT)
             ENDDO

/* Deallocate the source file member */

             DLCOBJ     OBJ((&LIBRARY/&SRCFILE *FILE *SHRUPD &SRCMBR))

/* If requested, display the output on CRT */

             IF         COND(&OUTPUT1 *EQ '*') THEN(DO)
               DSPSPLF    FILE(XV0006_P01) SPLNBR(*LAST)
               MONMSG     MSGID(CPF0000)
               DLTSPLF    FILE(XV0006_P01) SPLNBR(*LAST)
             ENDDO

/* Return to the calling program */

             RETURN

/* Unmonitored error processing routine */

 ERROR:      RCVMSG     MSGTYPE(*EXCP) MSGDTA(&MSGDTA) MSGID(&MSGID) +
                          MSGF(&MSGF) MSGFLIB(&MSGFLIB)
             SNDPGMMSG  MSGID(&MSGID) MSGF(&MSGFLIB/&MSGF) +
                          MSGDTA(&MSGDTA) MSGTYPE(*DIAG)

/* Attempt to deallocate the source file member if error occurs */

             DLCOBJ     OBJ((&LIBRARY/&SRCFILE *FILE *SHRUPD &SRCMBR))
             MONMSG     MSGID(CPF0000)

ENDPGM:      RETURN

             ENDPGM
