/*   *_> CNLLSTSPLF SRCFILE(@2/@1) SRCMBR(@3)                              */
     *_> DLTMOD MODULE(@5/@4)
     *_> CRTRPGMOD MODULE(@5/@4) SRCFILE(@2/@1) SRCMBR(@3) +
     *_>  DBGVIEW(@9) OPTIMIZE(@8) INDENT('|')
     *****************************************************************
     * Module XV0006_M03
     *                  List Calculations statements of a structured
     *                  program in Indented Format. Source File to
     *                  process will be associated in CLP program and
     *                  passed as a parameter. Program simply reads
     *                  the source file looking for Spec Filed Types.
     *                  When a C statement is
     *                  found, a check is made to see if it is a
     *                  comment. If yes, It will always be printed at
     *                  the first position but will not effect
     *                  indenture level. If not a comment, then the
     *                  code is check for key words IF, ELSE, DO, CAS
     *                  or END. Detection of an 'IF' or 'DO' will
     *                  cause an indent of indlvl with the next line
     *                  printed. 'ELSE' will be printed on same level
     *                  as last 'IF'. 'CAS' will be printed as it
     *                  except special processing must be carried out
     *                  to make sure the CASE END does not reduce the
     *                  Indent level. When 'END' is detected, will be
     *                  be printed at same level as last IF, ELSE OR
     *                  DO statement and the indent level will be
     *                  reduced by 1.
     *
     *   DATE    PROGRAMMER          CHANGES                         *
     * --------  ----------          -------                         *
     *                                                               *
     *****************************************************************
     fQRPGLESRC if   f  132        Disk    UsrOpn
     fXV0006_P01o    e             Printer Oflind(*In01)
     f                                     UsrOpn

     d PrintRPGIV      pr                  ExtProc('PrintRPGIV')
     d  PR_SrcFile                   10
     d  PR_SrcLib                    10
     d  PR_SrcMbr                    10
     d  PR_LevelsToIdent...
     d                                1p 0
     d  PR_FromRcdNum                 6p 2
     d  PR_ToRcdNum                   6p 2
     d  PR_Specs                     11
     d  PR_PrtComm                    1

     *----------------------------------------------------------------
     * System data structure fields needed
     d                SDS
     d UserRunningProgram...
     d                       254    263

     p PrintRPGIV      b                   export
     d                 pi
     d  InSrcFile                    10
     d  InSrcLib                     10
     d  InSrcMbr                     10
     d  InLevelsToIndent...
     d                                1p 0
     d  InFromRcdNum                  6p 2
     d  InToRcdNum                    6p 2
     d  InSpecs                      11
     d  InPrtCmt                      1

     *----------------------------------------------------------------
     * Constants
     d No              c                   Const('N')
     d Yes             c                   Const('Y')
     d XcErr           c                   Const('**ERROR**')
     d cCommentRcd...
     d                 c                   Const('*')
     d cTableRcd...
     d                 c                   Const('**')
     d cNumOfSpacesToIndent...
     d                 c                   Const(2)
     d cLo             c                   'abcdefghijklmnopqrstuvwxyz'
     d cUp             c                   'ABCDEFGHIJKLMNOPQRSTUVWXYZ'

     *----------------------------------------------------------------
     * Decode source line.
     d RecordIn        ds
     d  SrcSeq                        6s 2
     d  SrcDat                        6s 0
     d  SrcRcd                      120
     d  SrcRcdBytes12                 2    Overlay(SrcRcd:1)
     d  SrcRcdByte6                   1    OverLay(SrcRcd:6)
     d  SrcRcdByte7                   1    OverLay(SrcRcd:7)

     d PreviousLineLocation...                                                                   Print locat
     d                 s              3p 0 Dim(100)
     d SaveSpacers     s              1    Dim(25)                              Spacer's

     *----------------------------------------------------------------
     * Spec type array passed from command
     d RPGSpecs        ds
     d  CountOfSpecs           1      2b 0
     d  SpecTypes                     1    Dim(9)
     d                                     Ascend                               Spec types

     d ProcessThisRcd...
     d                 s              1
     d #P              s              3  0
     d AllSpecTypes    s              1
     d PrintFileOpen...
     d                 s              1    Inz(No)
     d L               s              3  0
     d PrintTables...
     d                 s              1
     d WA2             s              2
     d WA3             s              3
     d WA5             s              5
     d WA6             s              6
     d CurIndentLevel...
     d                 s              3  0 Inz(0)
     d wrkPrevOpCode   s              5
     d Index           s              3  0
     d SelectSeenFlag...
     d                 s              1
     d X               s              3  0
     d Y               s              5  0
     d TwoManyLevelsDeep...
     d                 s              1    Inz(No)
     d PrtLineNumChars...
     d                 s             10i 0
     d SrcRcdNumChars...
     d                 s             10i 0
     d UpRecordType    s              1
     d FirPartOfLn     s             25
     d SecPartOfLn     s             95
     *----------------------------------------------------------------
     * Open Input File.
     c                   Open      QRPGLESRC
     *----------------------------------------------------------------
     * Initialize starting values.
     c                   Eval      O_SRCMBR = InSrcMbr
     *----------------------------------------------------------------
     * Format source file name and library into one field with no
     * blanks.
     c                   Eval      O_FILELIBN = %trim(InSrcFile) +
     c                                          '.' +
     c                                          %Trim(InSrcLib)
     c                   Eval      O_USERNAM  = UserRunningProgram
     c                   Eval      RPGSpecs = InSpecs

     c                   Eval      PreviousLineLocation(1) = 1                                   First pos i
     *----------------------------------------------------------------
     * See if this is all spec types
     c                   If        SpecTypes(1) = 'Z'                           If all type req
     c                   Eval      AllSpecTypes  = Yes
     c                   Eval      PrintTables = Yes
     c                   Else                                                   Else-not all re
     *----------------------------------------------------------------
     * Initialize the rest of the spec array
     c                   For       Index = CountOfSpecs + 1
     c                               To %Elem(SpecTypes)
     c                   Eval      SpecTypes(Index) = *Blank
     c                   EndFor                                                 End-Do 8 times
     *----------------------------------------------------------------
     * Sort the array for faster processing
     c                   SortA     SpecTypes                                    Sort in ascendi
     c     'T'           Lookup    SpecTypes                              99    Lookup for tabl
     c                   If        %Equal                                       Table req fnd
     c                   Eval      PrintTables = Yes
     c                   EndIf                                                  End-If req fnd
     c                   EndIf                                                  End-If all req
     *----------------------------------------------------------------
     * Loop until EOF or greater than from record.
     c                   DoU       0 =1                                         Do-W not EOF
     c                   Exsr      srGetRecord                                       Get RPG source
     c                   Exsr      srProcessRcd                                  Test rec for in
     c                   Iter
     c                   EndDo                                                  End-W not EOF
     *
     *****************************************************************
     * srGetRecord - Get record from RPG source file.
     *****************************************************************
     c     srGetRecord   BegSr
     c                   Read      QRPGLESRC     RecordIn                       Read RPG source
     c                   If        %Eof(QRPGLESRC)
     c                   Exsr      srEndOfJob
     c                   EndIf
     c     cLo:cUp       Xlate     SrcRcdByte6   UpRecordType

     c                   EndSr
     *****************************************************************
     * srProcessRcd - Process record.
     *****************************************************************
     c     srProcessRcd  BegSr
     *
     c                   If        SRCSEQ < InFromRcdNum                        If >= srt seq
     c                   LeaveSr
     c                   EndIf

     c                   If        SRCSEQ > InToRcdNum                          If <= ending se
     c                   Exsr      srEndOfJob
     c                   EndIf
     *----------------------------------------------------------------
     * If start of table and print tables is yes, then call function
     *  to print Table Lines until EOF.
     c                   If        SrcRcdBytes12 = cTableRcd                             If start table
     c                   If        PrintTables = Yes                                   If table prt re
     c                   Exsr      srPrtTableLn                                       Prt all tables
     c                   EndIf                                                  End-If table re
     c                   EndIf
     *----------------------------------------------------------------
     * Should we process this spec type?
     c                   Eval      ProcessThisRcd = No
     c                   If        (SrcRcdByte7 = cCommentRcd and
     c                               InPrtCmt = No) or
     c                             (SrcRcd = *Blanks and
     c                               InPrtCmt = No)
     c                   Else
     c                   If        AllSpecTypes = Yes                                    If all prt req
     c                   Eval      ProcessThisRcd = Yes
     c                   Else
     c     UpRecordType  Lookup    SpecTypes                              99    Chk if type req
     c                   If        %Equal                                       ? type found
     c                   Eval      ProcessThisRcd = Yes
     c                   Else
     c                   If        SrcRcdByte7 = cCommentRcd and
     c                                  InPrtCmt = Yes
     c                   Eval      ProcessThisRcd = Yes
     c                   EndIf
     c                   Endif
     c                   Endif
     c                   Endif
     *----------------------------------------------------------------
     * If yes, then process record.
     c                   If        ProcessThisRcd = Yes
     c                   Select
     c                   When      UpRecordType = 'C' And
     c                             SrcRcdByte7 <> cCommentRcd
     c                   Exsr      srProcessCLn
     c                   Other
     c                   Exsr      srPrtMiscLn
     c                   EndSl
     c                   EndIf                                                  End-If comment

     c                   EndSr                                                  Endsr-srProcessRcd
     *****************************************************************
     * srPrtTableLn - Process table lines. Routine just loops around
     *                  lines until eof.
     *****************************************************************
     c     srPrtTableLn  BegSr
     c                   DoU       0 = 1                                        Do while not eo
     c                   Exsr      srGetRecord                                       Get RPG source
     c                   Exsr      srPrtMiscLn                                       Prt other line
     c                   Iter
     c                   EndDo                                                  End-W not EOF

     c                   EndSr                                                  Endsr-Proc tabl
     *****************************************************************
     * srProcessCLn - Process "C" line.
     *****************************************************************
     c     srProcessCLn  BegSr
     *----------------------------------------------------------------
     * Format dashes into indicator positions.
     c                   If        %Subst(SrcRcd:71:6) <> *Blanks               ? all blanks
     c                   If        %Subst(SrcRcd:71:2) = *Blanks                ? if no indicat
     c                   Eval      %Subst(SrcRcd:71:2) = '--'
     c                   EndIf                                                  End-If no high
     c                   If        %Subst(SrcRcd:73:2) = *Blanks                ? if no indicat
     c                   Eval      %Subst(SrcRcd:73:2) = '--'
     c                   EndIf                                                  End-If no low
     c                   If        %Subst(SrcRcd:75:2) = *Blanks                ? if no indicat
     c                   Eval      %Subst(SrcRcd:75:2) = '--'
     c                   EndIf                                                  End-If no equal
     c                   EndIf                                                  End-If all blan
     *----------------------------------------------------------------
     * Test for type of Calc line.
     c                   Eval      WA5 = %Subst(SrcRcd:26:%Size(wa5))
     c     cLo:cUp       Xlate     WA5           WA5
     c                   Eval      WA2 = %Subst(WA5:1:%Size(wa2))
     c                   Eval      WA3 = %Subst(WA5:1:%Size(Wa3))
     c     WA2           CasEq     *Blanks       srPrtBlkCLn
     c     WA2           CasEq     'IF'          srPrtIfLn
     c     WA2           CasEq     'DO'          srPrtDoLn
     c     WA2           CasEq     'OR'          srPrtOrLn
     c     WA2           CasEq     'WH'          srPrtWhenLn
     c     WA3           CasEq     'FOR'         srPrtForLn
     c     WA3           CasEq     'AND'         srPrtAndLn
     c     WA5           CasEq     'ELSE '       srPrintElseLn
     c     WA5           CasEq     'SELEC'       srPrtSelectLn
     c     WA5           CasEq     'OTHER'       srPrtOtherLn
     c     WA5           CasEq     'MONIT'       srPrtMonitLn
     c     WA5           CasEq     'ON-ER'       srPrtOn_ErLn
     c     WA5           CasEq     'BEGSR'       srPrtBegOrEnds
     c     WA5           CasEq     'ENDSR'       srPrtBegOrEnds
     c     WA3           CasEq     'END'         srPrtEndLn
     c                   Cas                     srPrtAnyOthC
     c                   EndCs
     c                   EndSr
     *****************************************************************
     * srPrtBlkCLn - Print blank op code "C" lines.
     *****************************************************************
     c     srPrtBlkCLn   BegSr
     *----------------------------------------------------------------
     * If op code is blank (We are here) and previous op code was an
     *  indent opcode, we want to print at the previous indent level.
     c                   If        wrkPrevOpCode = 'IF' or
     c                               wrkPrevOpCode = 'DO' or
     c                               wrkPrevOpCode = 'WH' or
     c                               wrkPrevOpCode = 'FOR' or
     c                               wrkPrevOpCode = 'MONIT' or
     c                               wrkPrevOpCode = 'ON-ER'
     c                   Eval      #P = CurIndentLevel
     c                   Else
     c                   Eval      #P = CurIndentLevel + 1
     c                   EndIf
     c                   Exsr      srPrintCLine

     c                   EndSr
     *****************************************************************
     * srPrtSelectLn - Print "SELEC" type calc statement.
     *****************************************************************
     c     srPrtSelectLn BegSr
     *----------------------------------------------------------------
     * Set SELEC flag to seen.
     c                   Eval      SelectSeenFlag = 'S'
     *
     c                   Eval      #P = CurIndentLevel + 1
     c                   Exsr      srPrintCLine
     c                   Eval      wrkPrevOpCode = 'SELEC'
     c                   EndSr
     *****************************************************************
     * srPrtIfLn - Print "IF" type calc statement.
     *****************************************************************
     c     srPrtIfLn     BegSr
     c                   Eval      #P = CurIndentLevel + 1
     c                   Eval      SaveSpacers(#P)= '|'
     c                   Exsr      srPrintCLine
     c                   Exsr      SrIncIndentLv
     c                   Eval      wrkPrevOpCode = 'IF'
     c                   EndSr
     *****************************************************************
     * srPrtWhenLn - Print "WH" type calc statement.
     *****************************************************************
     c     srPrtWhenLn   BegSr
     *----------------------------------------------------------------
     * If first WH after SELEC,
     c                   If        SelectSeenFlag = 'S'
     *----------------------------------------------------------------
     * Treat as if IF type statement,
     c                   Eval      #P = CurIndentLevel + 1
     c                   Eval      SaveSpacers(#P)= ':'
     c                   Exsr      srPrintCLine
     c                   Exsr      SrIncIndentLv
     *----------------------------------------------------------------
     * Else, at least one other WH seen,
     c                   Else
     *----------------------------------------------------------------
     * Treat as if Else statement.
     c                   Eval      #P = CurIndentLevel
     c                   Exsr      srPrintCLine
     *
     c                   EndIf
     *
     c                   Eval      wrkPrevOpCode = 'WH   '
     *----------------------------------------------------------------
     * Set SELEC flag to at least one WH or OTHER processed.
     c                   Eval      SelectSeenFlag = 'P'
     *
     c                   EndSr
     *****************************************************************
     * srPrtDoLn - Print "DO" type calc statement.
     *****************************************************************
     c     srPrtDoLn     BegSr
     c                   Eval      #P = CurIndentLevel + 1
     c                   Eval      SaveSpacers(#P)= '+'
     c                   Exsr      srPrintCLine
     c                   Exsr      srIncIndentLv
     c                   Eval      wrkPrevOpCode = 'DO   '
     c                   EndSr
     *****************************************************************
     * srPrtForLn - Print "FOR" type calc statement.
     *****************************************************************
     c     srPrtForLn    BegSr
     c                   Eval      #P = CurIndentLevel + 1
     c                   Eval      SaveSpacers(#P)= '^'
     c                   Exsr      srPrintCLine
     c                   Exsr      srIncIndentLv
     c                   Eval      wrkPrevOpCode = 'FOR  '
     c                   EndSr
     *****************************************************************
     * srPrtMonitLn - Print "Monitor" type calc statement.
     *****************************************************************
     csr   srPrtMonitLn  BegSr
     c                   Eval      #P = CurIndentLevel + 1
     c                   Eval      SaveSpacers(#P)= '~'
     c                   Exsr      srPrintCLine
     c                   Exsr      srIncIndentLv
     c                   Eval      wrkPrevOpCode = 'MONIT'
     csr                 EndSr
     *****************************************************************
     * srPrtOn_ErLn - Print "On-Error" type calc statement.
     *                 Assume Monitor has been seen. We need to go back
     *                  to previous print level.
     *****************************************************************
     csr   srPrtOn_ErLn  BegSr
     c                   Eval      #P = CurIndentLevel - 1
     c                   Exsr      srPrintCLine
     c                   Eval      wrkPrevOpCode = 'ON_ER'
     csr                 EndSr
     *****************************************************************
     * srPrtOtherLn - Print "OTHER" type calc.
     *****************************************************************
     c     srPrtOtherLn  BegSr
     *----------------------------------------------------------------
     * If first OTHER after SELEC,
     c                   If        SelectSeenFlag = 'S'
     *----------------------------------------------------------------
     * Treat as if IF type statement,
     c                   Eval      #P = CurIndentLevel + 1
     c                   Eval      SaveSpacers(#P)= ':'
     c                   Exsr      srPrintCLine
     c                   Exsr      SrIncIndentLv
     *----------------------------------------------------------------
     * Else, at least one other WH seen,
     c                   Else
     *----------------------------------------------------------------
     * Treat as if Else statement.
     c                   Eval      #P = CurIndentLevel
     c                   Exsr      srPrintCLine
     *
     c                   EndIf
     *
     c                   Eval      wrkPrevOpCode = 'OTHER'
     *----------------------------------------------------------------
     * Set SELEC flag to at least one WH or OTHER processed.
     c                   Eval      SelectSeenFlag = 'P'
     *
     c                   EndSr
     *****************************************************************
     * srPrintElseLn - Print "ELSE" type line. "ELSE" is printed at last
     *                  indenture level and everything else stays the same.
     *****************************************************************
     c     srPrintElseLn BegSr
     c                   Eval      #P = CurIndentLevel
     c                   Exsr      srPrintCLine
     c                   Eval      wrkPrevOpCode = 'ELSE '
     c                   EndSr
     *****************************************************************
     * srPrtOrLn - Process "OR" type line. Process same as "ELSE".
     *****************************************************************
     c     srPrtOrLn     BegSr
     c                   Eval      #P = CurIndentLevel
     c                   Exsr      srPrintCLine
     c                   Eval      wrkPrevOpCode = 'OR   '
     c                   EndSr
     *****************************************************************
     * srPrtAndLn - Process "AND" type line. Process same as "ELSE"
     *****************************************************************
     c     srPrtAndLn    BegSr
     c                   Eval      #P = CurIndentLevel
     c                   Exsr      srPrintCLine
     c                   Eval      wrkPrevOpCode = 'AND  '
     c                   EndSr
     *****************************************************************
     * srPrtEndLn - Process "END" type line.
     *****************************************************************
     c     srPrtEndLn    BegSr
     c                   If        %Subst(wrkPrevOpCode:1:3) = 'CAS'
     *----------------------------------------------------------------
     * If last OP code as an "CAS" then process this "END" just like
     * other lines "C" line.
     c                   Exsr      srPrtAnyOthC
     *----------------------------------------------------------------
     * else, then is a real "END".
     c                   Else
     c                   Eval      #P = CurIndentLevel
     c                   Exsr      srPrintCLine
     c                   If        CurIndentLevel > 0
     c                   Eval      CurIndentLevel = CurIndentLevel - 1
     c                   EndIf
     c                   EndIf
     c                   Eval      wrkPrevOpCode = 'END  '
     c                   EndSr
     *****************************************************************
     * srPrtAnyOthC - Print any other type of calc line.
     *****************************************************************
     c     srPrtAnyOthC  BegSr
     c                   Eval      #P = CurIndentLevel + 1
     c                   Exsr      srPrintCLine
     c                   Eval      wrkPrevOpCode = %Subst(SrcRcd:26:5)
     c     cLo:cUp       Xlate     wrkPrevOpCode wrkPrevOpCode
     c                   EndSr
     *****************************************************************
     * srPrtBegOrEnds - Process for Begin or End Subroutine. #P should
     *                  zero.
     *****************************************************************
     c     srPrtBegOrEndsBegSr
     c                   If        CurIndentLevel > 0
     *----------------------------------------------------------------
     * Set line pointer to force srPrintCLine to process as error and
     * zero indenture level.
     c                   Eval      #P = 0 - 1
     c                   Eval      CurIndentLevel = 0
     c                   Else
     c                   Eval      #P = CurIndentLevel + 1
     c                   EndIf
     c                   Exsr      srPrintCLine
     c                   Eval      wrkPrevOpCode = %Subst(SrcRcd:26:5)
     c     cLo:cUp       Xlate     wrkPrevOpCode wrkPrevOpCode
     c                   EndSr
     *****************************************************************
     * srPrtMiscLn - Print lines other than "C" or comment lines.
     *****************************************************************
     c     srPrtMiscLn   BegSr
     c                   If        PrintFileOpen = No
     c                   Exsr      srFirstTimPrt
     c                   EndIf
     c                   Eval      O_SRCSEQ = SrcSeq
     c                   Eval      O_SRCRCD = SrcRcd
     c                   If        *In01 = *On
     c                   Exsr      srWriteNewPage
     c                   EndIf
     c                   Write     RP01_03
     c                   EndSr
     *****************************************************************
     * srPrintCLine - Print "C" lines using  variable "L" to point to
     *                location in line to move code to.
     *****************************************************************
     c     srPrintCLine  BegSr

     c                   If        PrintFileOpen = No
     c                   Exsr      srFirstTimPrt
     c                   EndIf
     *----------------------------------------------------------------
     * Protect against two many end or else.
     c                   If        #P <= 0
     c                   Eval      #P = 1
     c                   Eval      TwoManyLevelsDeep = Yes
     c                   EndIf
     *
     c                   Eval      L = PreviousLineLocation(#P)
     c                   Eval      SecPartOfLn = *Blanks
     c                   Eval      FirPartOfLn =
     c                                  %Subst(SrcRcd:1:
     c                                         %size(FirPartOfLn))
     c                   If        TwoManyLevelsDeep = Yes
     c                   Eval      %Subst(FirPartOfLn:1:%Size(XCERR)) =
     c                                      XCERR
     c                   Eval      TwoManyLevelsDeep = No
     c                   EndIf
     c                   Eval      PrtLineNumChars =
     c                                     (%size(SecPartOfLn) - L) + 1
     c                   Eval      SrcRcdNumChars =
     c                                     (%size(SrcRcd) - 26) + 1
     c                   If        SrcRcdNumChars >
     c                                  PrtLineNumChars
     c                   Eval      SrcRcdNumChars =
     c                                  PrtLineNumChars
     c                   EndIf
     c                   Eval      %subst(SecPartOfLn:L:PrtLineNumChars)
     c                               = %subst(SrcRcd:26:SrcRcdNumChars)
     *----------------------------------------------------------------
     * Format spacers into line.
     c                   For       Index = 1
     c                                To CurIndentLevel
     c                   Eval      Y = PreviousLineLocation(Index)
     c                   If        %Subst(SecPartOfLn:Y:1) = *Blank
     c                   Eval      %Subst(SecPartOfLn:Y:1) =
     c                                        SaveSpacers(Index)
     c                   EndIf
     c                   EndFor
     c                   Eval      O_SRCSEQ = SrcSeq
     c                   Eval      O_SRCRCD = FirPartOfLn + SecPartOfLn
     c                   If        *In01 = *On
     c                   Exsr      srWriteNewPage
     c                   EndIf
     c                   Write     RP01_03
     c                   EndSr
     *****************************************************************
     * srIncIndentLv - Increment indent level for "IF","DO","WH" type
     *                  lines.
     *****************************************************************
     c     srIncIndentLv BegSr
     c                   Eval      L = L + InLevelsToIndent
     c                   Eval      CurIndentLevel = CurIndentLevel + 1
     c                   Eval      X = CurIndentLevel + 1
     c                   Eval      PreviousLineLocation(X) = L
     c                   EndSr
     *****************************************************************
     * srWriteNewPage - Write blank new page header.                       ders.
     *****************************************************************
     c     srWriteNewPageBegSr
     c                   Write     RP01_02
     c                   Eval      *In01 = *Off
     c                   EndSr
     *****************************************************************
     * srFirstTimPrt  - First time to print.                               ders.
     *****************************************************************
     c     srFirstTimPrt BegSr

     c                   Open      XV0006_P01
     c                   Write     RP01_01
     c                   Eval      PrintFileOpen = Yes

     c                   EndSr
     *****************************************************************
     * srEndOfJob - End Of Job Processing.                                 ders.
     *****************************************************************
     c     srEndOfJob    BegSr

     c                   If        %Open(XV0006_P01)
     c                   Close     XV0006_P01
     c                   EndIf
     c                   If        %Open(QRPGLESRC)
     c                   Close     QRPGLESRC
     c                   EndIf
     c                   Eval      *InLr = *On
     c                   Return

     c                   EndSr
     p PrintRPGIV      e
